MyBankApp/Areas/Admin/Controllers/UserController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using MyBankApp.Areas.Administration.Controllers;
using MyBankApp.Core.Constants;
using MyBankApp.Core.Services.Contracts;
using MyBankApp.Core.ViewModels;
using MyBankApp.Infrastructure.Entities;

namespace MyBankApp.Areas.Admin.Controllers
{
    public class UserController : BaseController
    {
        private readonly IUserService userService;
        private readonly IAccountService accountService;
        private readonly RoleManager<IdentityRole> roleManager;
        private readonly UserManager<ApplicationUser> userManager;

        public UserController(IUserService userService, IAccountService accountService, RoleManager<IdentityRole> roleManager, UserManager<ApplicationUser> userManager)
        {
            this.userService = userService;
            this.accountService = accountService;
            this.roleManager = roleManager;
            this.userManager = userManager;
        }

        public async Task<IActionResult> Delete(string id)
        {
            try
            {
                var currUser = await userManager.FindByIdAsync(id);
                var role = await userManager.GetRolesAsync(currUser);

                if (role.Contains("Administrator"))
                {
                    throw new ArgumentException(MessageConstant.AdminCantBeDeletedMessage);
                }
            }
            catch (ArgumentException ex)
            {

                return BadRequest(ex.Message);
            }

            await userService.Delete(id);

            return Redirect("/Admin/Home/Index");
        }

        public async Task<IActionResult> Info(string id)
        {


            var model = await accountService.Info(id);
            return View(model);
        }

        public async Task<IActionResult> Edit(string userId)
        {
            var user = await userManager.FindByIdAsync(userId);
            var userRoles = await userManager.GetRolesAsync(user);
            var allRoles = roleManager.Roles
                .Where(r => r.Name != "Administrator")
                .ToList();

            var model = userService.GetUser(userId, user, userRoles, allRoles);
            return View(model);
        }

        [HttpPost]
        public async Task<IActionResult> Edit(EditUserViewModel model)
        {
            if (!ModelState.IsValid)
            {
                return View(model);
            }

            var identityUser = await userManager.FindByIdAsync(model.Id);
            var role = await roleManager.FindByNameAsync(model.SelectedRole);

            var userHasRole = await userManager.GetRolesAsync(identityUser);

            if (userHasRole.FirstOrDefault() != null)
            {
                var roleToRemove = await userManager.GetRolesAsync(identityUser);
                await userManager.RemoveFromRoleAsync(identityUser, roleToRemove[0]);

                if (role != null)
                {
                    await userManager.AddToRoleAsync(identityUser, model.SelectedRole);
                }
            }
            else if (role != null)
            {
                await userManager.AddToRoleAsync(identityUser, model.SelectedRole);
            }

            await userService.Edit(model);

            return Redirect("/Admin/Home/Index");
        }

        public async Task<IActionResult> CreateRole()
        {
            //await roleManager.CreateAsync(new IdentityRole()
            //{
            //    Name = "User"
            //});

            //await roleManager.CreateAsync(new IdentityRole()
            //{
            //    Name = "PremiumUser"
            //});

            return Ok();
        }
    }
}

MyBankApp/Controllers/UserController.cs
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;

namespace MyBankApp.Controllers
{
    public class UserController : BaseController
    {
        private readonly RoleManager<IdentityRole> roleManager;

        public UserController(RoleManager<IdentityRole> roleManager)
        {
            this.roleManager = roleManager;
        }

        public IActionResult Index()
        {
            return View();
        }

        public async Task<IActionResult> CreateRole()
        {
            await roleManager.CreateAsync(new IdentityRole
            {
                Name = "PremiumUser"
            });

            return Ok();
        }
    }
}

MyBankApp/Areas/Admin/Views/User/Edit.cshtml
@model EditUserViewModel

@{
    var count = 1;
}

<form asp-area="Admin" asp-controller="User" asp-action="Edit" asp-route-userId="@Model.Id" method="post">
    <div class="row">
        <input type="hidden" asp-for="@Model.Id" />
        <div class="col">
            <label asp-for="@Model.FirstName" class="form-label">First name</label>
            <input asp-for="@Model.FirstName" placeholder="FirstName" class="form-control" autocomplete="username" aria-required="true" />
            <span asp-validation-for="@Model.FirstName" class="text-danger"></span>
        </div>
        <div class="col">
            <label asp-for="@Model.LastName" class="form-label">Last name</label>
            <input asp-for="@Model.LastName" placeholder="LastName" class="form-control" autocomplete="username" aria-required="true" />
            <span asp-validation-for="@Model.LastName" class="text-danger"></span>
        </div>
        <div class="col">
            <label asp-for="@Model.Email" class="form-label">Email</label>
            <input asp-for="@Model.Email" placeholder="Email" class="form-control" autocomplete="username" aria-required="true" />
            <span asp-validation-for="@Model.Email" class="text-danger"></span>
        </div>

        <div class="col">
            <label asp-for="@Model.SelectedRole" class="form-label">Current Role</label>
            <input disabled asp-for="@Model.SelectedRole" class="form-control" autocomplete="username" aria-required="true" />
        </div>

        <div class="col">
            <label asp-for="@Model.IsDeleted" class="form-label">IsDeleted</label>
            <br />
            @if (User.Identity.Name != Model.Email)
            {
                <input class="form-check-input" type="checkbox" asp-for="@Model.IsDeleted" placeholder="IsDeleted" class="form-control" autocomplete="username" aria-required="true" />
            }
            else
            {
                <p>Administrator can't be deleted</p>
            }
            <span asp-validation-for="@Model.IsDeleted" class="text-danger"></span>
        </div>
    </div>

    @if (Model.SelectedRole != "Administrator")
    {
        <div class="row">
            <div class="col-sm-6">
                <label asp-for="SelectedRole" class="form-label">Change role</label>
                <select class="form-select" aria-label="Default select example" name="SelectedRole">
                    <option selected >No Role</option>
                    @foreach (var role in Model.Roles)
                    {
                        if (Model.SelectedRole == role.Name)
                        {
                            <option selected value="PremiumUser">@role.ToString()</option>
                        }
                        else
                        {
                            <option value="PremiumUser">@role.ToString()</option>
                        }
                    }
                    @*<option selected value="User">User</option>
                        <option value="PremiumUser">PremiumUser</option>*@
                </select>
            </div>
        </div>
    }

    <div class="col-sm-6">
        <button type="submit" class="btn btn-primary" name="submit">
            Submit
        </button>
    </div>
</form>

MyBankApp/Areas/Admin/Views/User/Info.cshtml
@model ICollection<AllAccountsViewModel>

@{
    var count = 1;
}

<h2>Iformation for: @Model.First().User.FirstName @Model.First().User.LastName</h2>

<table class="table table-striped">
    <thead>
        <tr>
            <th scope="col">#</th>
            <th scope="col">Name</th>
            <th scope="col">Account</th>
            <th scope="col">Balance</th>
            <th scope="col">Date</th>
            <th></th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var account in @Model)
        {
            <tr>
                <th scope="row">@(count++)</th>
                <td>@account.NickName</td>
                <td>@account.AccountNumber</td>
                <td>@account.Balance</td>
                <td>@account.Date</td>
                <td>
                    <a class="btn btn-outline-warning" asp-area="Admin" asp-controller="Account" asp-action="Edit" asp-route-id="@account.Id" asp-route-userId="@account.User.Id" model="Get">Edit</a>
                </td>
                <td>
                    
                        <a asp-controller="Account" asp-action="Delete" asp-route-id="@account.Id">
                            <button type="submit" class="btn btn-outline-danger">Delete</button>
                        </a>
                    
                </td>
            </tr>
        }
    </tbody>
</table>